package xugu

import "unsafe"

// 定义 HANDLE_TYPE 枚举
type HANDLE_TYPE int

const (
	HT_UNKNOW   HANDLE_TYPE = iota // 0 未知
	HT_CONN                        // 1 连接
	HT_PARAMS                      // 2 参数
	HT_ERR                         // 错误
	HT_RS                          // 结果
	HT_LOB                         // 大对象
	HT_SMART_RS                    // 智能结果集
)

// 定义 XGCSParam 结构体
type XGCSParam struct {
	Type           HANDLE_TYPE       // 句柄类型
	ParamNum       uint32            // 单行参数数量
	PResourceNum   int               // 参数名称资源数量，步长128
	ParamArraySize int               // 参数数组长度（数组大小）
	Valuep         ***unsafe.Pointer // 实际参数指针数组，指向参数地址
	VType          []uint32          // 参数类型：数组，参数数量
	VParamSize     []uint32          // 参数缓冲区长度，参数数量
	VDbType        *int              // 参考数据库数据类型，参数数量
	VActuallenp    **int             // 参数数据实际大小数组，[参数数组大小][参数数量]
	VParamName     [][]byte          // 参数名称
	VParamNo       []uint32          // 参数序列数组
	VInOut         *int              // 输入输出类型
	ErrStr         *byte             // 错误字符串
	MemType        int               // 内存使用模式（0：引用，1：驱动程序分配）
	ImpExpType     int               // 0 隐式创建，1 显式创建，2 由服务器提供的准备语句获取
}

const (
	XG_ERROR        = -1
	XG_NET_ERROR    = -4
	XG_INVALID_ARG  = -3
	XG_SOCKET_ERROR = -8
	XG_LOGIN_ERROR  = -9
)
